/********************						***********************/
//
//	Player PRO 5.0 - DRIVER SOURCE CODE -
//
//	Library Version 5.0
//
//	To use with MAD Library for Mac: Symantec, CodeWarrior and MPW
//
//	Antoine ROSSET
//	16 Tranchees
//	1206 GENEVA
//	SWITZERLAND
//
//	COPYRIGHT ANTOINE ROSSET 1996, 1997, 1998
//
//	Thank you for your interest in PlayerPRO !
//
//	FAX:				(+41 22) 346 11 97
//	PHONE: 			(+41 79) 203 74 62
//	Internet: 	RossetAntoine@bluewin.ch
//
/********************						***********************/

#ifndef COMPIL68K 
#pragma options align=mac68k
#endif

typedef struct ITPatForm
{
	unsigned short		length;
	unsigned short		row;
	long				no;
	char				data[];
} ITPatForm;

typedef struct ITSampForm
{
	long		ID;
	char		DOSName[ 12];
	Byte		no;
	Byte		GvL;
	Byte		Flag;
	Byte		Vol;
	char		SampName[ 26];
	short	Convert;
	long		length;
	long		loopBegin;
	long		loopEnd;
	long		C5Speed;
	long		SusLoopBegin;
	long		SusLoopEnd;
	long		samplePtr;
	Byte		ViS;
	Byte		ViD;
	Byte		ViR;
	Byte		ViT;
} ITSampForm;

typedef struct ITNode
{
	char		y;
	short	x;
} ITNode;

typedef struct ITEnv
{
	Byte		Flag;
	Byte		Num;
	Byte		LpB;
	Byte		LpE;
	Byte		SLB;
	Byte		SLE;
	ITNode	nodes[25];
} ITEnv;

typedef struct ITKeyMap
{
	Byte		note;
	Byte		samp;
} ITKeyMap;

typedef struct ITInsForm		// size = 547
{
	long		ID;
	char		DOSName[ 12];
	Byte		no;
	Byte		NNA;
	Byte		DCT;
	Byte		DCA;
	short	FadeOut;
	Byte		PPS;
	Byte		PPC;
	Byte		GbV;
	Byte		DfP;
	char		no2[ 2];
	short	TrkVers;
	Byte		NoS;
	Byte		no3;
	char		INSName[ 26];
	char		no4[ 6];
	ITKeyMap	keyMap[ 120];
	
	// new structure
	
	ITEnv	volEnv;
	ITEnv	panEnv;
	ITEnv	pitchEnv;
	
} ITInsForm;

typedef struct ITOldInsForm		// size = 554
{
	long		ID;
	char		DOSName[ 12];
	Byte		no;
	Byte		NNA;
	Byte		DCT;
	Byte		DCA;
	short	FadeOut;
	Byte		PPS;
	Byte		PPC;
	Byte		GbV;
	Byte		DfP;
	char		no2[ 2];
	short	TrkVers;
	Byte		NoS;
	Byte		no3;
	char		INSName[ 26];
	char		no4[ 6];
	ITKeyMap	keyMap[ 120];
	
	// old structure
	
	ITKeyMap	volEnv[ 100];
	
} ITOldInsForm;

typedef struct ITForm
{
	long				ID;
	char             		name[26];
	char             		no[ 2];
	
	short  			orderNum;
	short   			insNum;
	short   			smpNum;
	short      			patNum;
	short     			cwtv;
	short			cmwt;
	short      			flags;
	short			special;
	
	Byte				globalVol;
	Byte				mixVol;
	Byte				iSpeed;
	Byte				iTempo;
	char				panSeparation;
	char				null;
	short			MsgLgth;
	long				MsgOffset;
	char				no2[ 4];
	
	char				chanPan[ 64];
	char				chanVol[ 64];
	
	unsigned char  		*orders;
	long				*parapins;
	long				*parapsamp;
	long				*parappat;
	
	ITInsForm			*insdata;
	ITSampForm		*sampdata;
} ITForm;
#ifndef COMPIL68K        
#pragma options align=power
#endif